/*
 *  Author: Pawel Parys <parys@mimuw.edu.pl> (2003-2004)
 *
 *  For licence see doc/LICENCE.
 */

#ifndef __GLOBALPROP_H
#define __GLOBALPROP_H

#include "propagator.h"
#include <utility>
#include <vector>

using namespace std;

/* This module implements global propagator, which says that activities can
 * not be at the same time. It do not filter out everything, there can be
 * some values left, which in fact are impossible. */

namespace Propagators
{

class AllDisjointPropagator : public Propagator
{
	vector<pair<int, int> > activities;
	int globNo;
public:
	AllDisjointPropagator(Spaces::Space &sp, const vector<pair<int, int> > &activities, int globNo = -1);
	virtual void Propagate(Spaces::Space &sp, int myNo);
};

} // namespace Propagators

#endif
